<CsoundSynthesizer>
<CsInstruments>


# define RESCALE # 8 #

instr 1
;	INS 0 1
;	OSC P5 P6 B2 F1 P30 ;
;	RAN B2 P8 B2 P29 P27 P26 ;
;	OSC B2 P7 B2 F2 P28 ;
;	OUT B2 B1 ;
;	END ; 

	iamp = p4
	icf  = cpspch( p5 )  ; center frequency of bandpass
	ibw  = icf * p6      ; bandwidth amount, 0 to 1

	a2 oscil iamp, 1 / p3, 1
	a2 randi a2, ibw
	a2 oscil a2, icf, 2

	out a2 * $RESCALE
endin




instr 2
;	INS 0 2 ;
;	OSC P5 P6 B2 F1 P30 ;
;	RAN P8 P9 B3 P29 P27 P26 ;
;	AD2 P7 B3 B3 ;
;	OSC B2 B3 B2 F2 P28 ;
;	OUT B2 B1 ;
;	END ;

;	p4 = amplitude
;	p5 = not used, replaced with 1 / p3
;	p6 = center frequency
;	p7 = maximum instantaneous deviation of frequency of oscil
;	p8 = rate the frequency of oscil deviates

	iamp  = p4
	icf   = cpspch( p5 )
	idev  = icf * p6      ; 0 to 1
	irate = idev * p7
	
	a2 oscil iamp, 1 / p3, 1
	a3 randi idev, irate
	a3 =     icf + a3
	a2 oscil a2, a3, 2
	
	out a2 * $RESCALE	
endin




instr 3
; Orignal Instrument Design by J.C. Tenny
;
;	INS 0 3 ;
;	OSC P5 P6 B2 F1 P30 ;
;	OSC P8 V1 B3 F3 P29 ;
;	RAN P9 V2 B4 P28 P26 P25 ;
;	AD3 P7 B3 B4 B3 ;
;	OSC B2 B3 B2 F2 P27 ;
;	OUT B2 B1 ;
;	END ;


	iamp  = p4
	ipch  = int( cpspch( p5 ) )
	ivpv  = p6                   ; vibrato periodic variation
	ivrv  = p7                   ; vibrato random variation
	irate = p8                   ; vibrato rate
	ibw   = p9                   ; random bandwitdth rate

	iv1 = 8
	iv2 = 16
	
	a2 oscil iamp, 1 / p3, 1
	a3 oscil ivpv, irate, 3
	a4 randi ivrv, ibw
	a3 =     ipch + a3 + a4
	a2 oscil a2, a3, 2
	out a2 * $RESCALE

endin



</CsInstruments>
<CsScore>
f1 0 512 -7 0 20 .99 471 .99 20 0
f2 0 512 -10 1
f3 0 512 -10 1

i1 0 2 512 7.00  .1
i1 + . .   8.00  .
i1 + . .   9.00  .
i1 + . .   10.00 .
i1 + . .   11.00 .
i1 + . .   12.00 .

s
f0 1
s

i2 0 2 512 7.00  .1  5
i2 + . .   8.00  .   .
i2 + . .   9.00  .   .
i2 + . .   10.00 .   .
i2 + . .   11.00 .   .
i2 + . .   12.00 .   .

s
f0 1
s

i3 0 2 512 7.00  .1  5 8 16
i3 + . .   8.00  .   . . .
i3 + . .   9.00  .   . . .
i3 + . .   10.00 .   . . .
i3 + . .   11.00 .   . . .
i3 + . .   12.00 .   . . .

e

</CsScore>

</CsoundSynthesizer>