<CsoundSynthesizer>
<CsInstruments>

# define RESCALE  # 8 #


instr 4
	idur    = p3
	iamp    = 10^(p4 / 20)             ; amplitude in dB
	ipch    = int( cpspch( p5 ) )      ; pitch
	iattack = p6                       ; attack time
	idecay  = p7                       ; decay time
	ivib    = p8                       ; rate of vibrato in Hz
	iamt    = ipch * p9                ; amount of vibrato
	
	isteady = idur - iattack - idecay
	
	if( isteady < 0 ) goto nosteady
		a2 linseg 0, iattack, 127, idur - iattack - idecay, 255, idecay, 383
		a2 table a2, 1

		goto continue
	

	nosteady:
		iscale =  1 - ( ( -1 * isteady ) / ( iattack + idecay ) )
	
		a2 linseg 0, iattack * iscale, 127, 0, 256, idecay * iscale, 383
		a2 table a2, 1

	continue:
	
	a2 =     a2 * iamp
	a3 oscil iamt, ivib, 3
	a3 =     ipch + a3
	a2 oscil a2, a3, 2
	out a2 * $RESCALE
endin


</CsInstruments>
<CsScore>
f1 0 512 -7 0 96 1 32 .7 22 1 25 .6 25 1 25 .7 31 1 64 .3 64 0 127 0 ;
f2 0 512 -7 0 50 .999 155 .999 101 -.999 155 -.999 50 0
f3 0 8192 -10 .999

t 0 30
;t 0 300  ; * NOTE:  The book says quarter note should equal 300.

i4 0  .1  54 8.05 .050 .100 5.87 .0075
i4 .2 .1  54 8.07 .    .    .    .
i4 .5 .13 54 8.09 .    .    .    .
i4 .6 .2  54 8.05 .    .    .    .
i4 0 .8   54 8.00 .    .    .    .

</CsScore>

</CsoundSynthesizer>