<CsoundSynthesizer>
<CsInstruments>


# define RESCALE # 8 #

instr 1

	istart    = p2
    	igain     = p4
	itable1_a = p5
	itable2_a = p6
	itable1_b = p7
	itable2_b = p8
	ibasepch  = p9
	itempo    = p10
	
	; Number of note events
	ievents_a   = itable2_a - itable1_a
	ievents_b   = itable2_b - itable1_b
	
	; get total duration of theme B

	ictr      = 0
	ilength_b = 0;

	
	
	
	
	getduration:
	
		; get the start time and duration of each note in theme b	
	
		itemp1 tablei 0, ictr + itable1_b
		itemp2 tablei 1, ictr + itable1_b
		
		
		; get duration of theme a
	
		if( ilength_b < ( itemp1 + itemp2 ) ) then
			ilength_b = itemp1 + itemp2
		endif
		
	
		; control statement stuff
	
		ictr = ictr + 1
		if( ictr <= ievents_b ) igoto getduration
	
	
	
	
	; create score events
	
	ictr  = 0

	theme_a:
	
		istart_a tablei 0, ictr + itable1_a
		idur_a   tablei 1, ictr + itable1_a
		ipch_a   tablei 2, ictr + itable1_a
		iamp_a   tablei 3, ictr + itable1_a
	
		
		
		ictr2 = 0;
		print ipch_a
		theme_b:	

			istart_b tablei 0, ictr2 + itable1_b
			idur_b   tablei 1, ictr2 + itable1_b
			ipch_b   tablei 2, ictr2 + itable1_b
			iamp_b   tablei 3, ictr2 + itable1_b
		
			iwhen = istart_a + ( istart_b / ilength_b * idur_a )
			idur  = idur_a * idur_b / ilength_b
			ipch  = cpspch( ibasepch )  * ( 2^( ( ipch_a + ipch_b ) / 12 ) ) 
			iamp  = iamp_a * iamp_b * igain

			print ipch			
			itmp  = 60 / itempo
			
			iwhen = iwhen * itmp
			
			event_i "i", 2, iwhen, idur * itmp, iamp, ipch

			ictr2 = ictr2 + 1
			if( ictr2 <= ievents_b ) igoto theme_b

			
			

		ictr = ictr + 1
		if( ictr <= ievents_a ) igoto theme_a
	
endin







instr 2
	a2 oscil  p4 * $RESCALE, p5, 1
	out a2
endin









</CsInstruments>
<CsScore>

f1 0 512 -7 0 50 .999 155 .999 101 -.999 155 -.999 50 0

; Structure of a theme table
; [0] = start time
; [1] = duration
; [2] = note, in half steps relative to starting base pitch
; [3] = amplitude

f30 0 4 -2 0   2   0 316.225
f31 0 4 -2 2   2   4 446.685
f32 0 4 -2 4   1.5 2 630.967
f33 0 4 -2 5.5 0.5 -3 891.250
f34 0 4 -2 6   2   0 1258.92

f40 0 4 -2 0   1.08 0  1.584
f41 0 4 -2 1.5 .375  2 1.258
f42 0 4 -2 2   .75  -1 1
f43 0 4 -2 3   .75  0  .794
f44 0 4 -2 4   0    0  0      ; required for theme duration to equal 4



# define TEMPO # 60 #
t 0 $TEMPO

; Theme A * Theme B
i1 0 0 1 30 34 40 44 8.05 $TEMPO


; Theme A * Theme B != Theme B * Theme A       * Not Commutative
i1 10 0 1 40 44 30 34 8.05 $TEMPO
e 14


</CsScore>

</CsoundSynthesizer>